Skip to main content

Read a Custom Connector Plugin

GET 

/connect/v1/custom-connector-plugins/:id

General Availability

Make a request to read a custom connector plugin.

Request

Responses

Custom Connector Plugin.

Response Headers
    X-Request-Id

    The unique identifier for the API request.

    X-RateLimit-Limit

    The maximum number of requests you're permitted to make per time period.

    X-RateLimit-Remaining

    The number of requests remaining in the current rate limit window.

    X-RateLimit-Reset

    The relative time in seconds until the current rate-limit window resets.

    Important: This differs from Github and Twitter's same-named header which uses UTC epoch seconds. We use relative time to avoid client/server time synchronization issues.

OpenAPI definition (YAML)
paths:
  /connect/v1/custom-connector-plugins/{id}:
    get:
      x-lifecycle-stage: General Availability
      x-self-access: true
      operationId: getConnectV1CustomConnectorPlugin
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Make a request to read a custom connector plugin.'
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: string
        description: The unique identifier for the custom connector plugin.
      tags:
      - Custom Connector Plugins (connect/v1)
      security:
      - cloud-api-key: []
      - confluent-sts-access-token: []
      responses:
        '200':
          description: Custom Connector Plugin.
          content:
            application/json:
              schema:
                allOf:
                - type: object
                  description: 'CustomConnectorPlugins objects represent Custom Connector Plugins on Confluent
                    Cloud.

                    The API allows you to list, create, read, update, and delete your Custom Connector
                    Plugins.

                    Related guide:

                    [Custom Connector Plugin API](https://docs.confluent.io/cloud/current/connectors/connect-api-section.html).



                    ## The Custom Connector Plugins Model

                    <SchemaDefinition schemaRef="#/components/schemas/connect.v1.CustomConnectorPlugin"
                    />'
                  properties:
                    api_version:
                      type: string
                      enum:
                      - connect/v1
                      description: APIVersion defines the schema version of this representation of a resource.
                      readOnly: true
                    kind:
                      type: string
                      description: Kind defines the object this REST resource represents.
                      readOnly: true
                      enum:
                      - CustomConnectorPlugin
                    id:
                      description: ID is the "natural identifier" for an object within its scope/namespace;
                        it is normally unique across time but not space. That is, you can assume that
                        the ID will not be reclaimed and reused after an object is deleted ("time"); however,
                        it may collide with IDs for other object `kinds` or objects of the same `kind`
                        within a different scope/namespace ("space").
                      type: string
                      maxLength: 255
                      readOnly: true
                      example: dlz-f3a90de
                    metadata:
                      allOf:
                      - description: ObjectMeta is metadata that all persisted resources must have, which
                          includes all objects users must create.
                        required:
                        - self
                        properties:
                          self:
                            description: Self is a Uniform Resource Locator (URL) at which an object can
                              be addressed. This URL encodes the service location, API version, and other
                              particulars necessary to locate the resource at a point in time
                            type: string
                            format: uri
                            readOnly: true
                            example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                          resource_name:
                            description: Resource Name is a Uniform Resource Identifier (URI) that is
                              globally unique across space and time. It is represented as a Confluent
                              Resource Name
                            type: string
                            format: uri
                            readOnly: true
                            example: crn://confluent.cloud/kafka=lkc-f3a90de
                          created_at:
                            type: string
                            format: date-time
                            example: '2006-01-02T15:04:05-07:00'
                            readOnly: true
                            description: The date and time at which this object was created. It is represented
                              in RFC3339 format and is in UTC.
                          updated_at:
                            type: string
                            format: date-time
                            example: '2006-01-02T15:04:05-07:00'
                            readOnly: true
                            description: The date and time at which this object was last updated. It is
                              represented in RFC3339 format and is in UTC.
                          deleted_at:
                            type: string
                            format: date-time
                            example: '2006-01-02T15:04:05-07:00'
                            readOnly: true
                            description: The date and time at which this object was (or will be) deleted.
                              It is represented in RFC3339 format and is in UTC.
                        readOnly: true
                        title: ObjectMeta
                      - properties:
                          self:
                            example: https://api.confluent.cloud/connect/v1/custom-connector-plugins/ccp-12345
                          resource_name:
                            example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/custom-connector-plugin=ccp-12345
                    display_name:
                      type: string
                      description: Display name of Custom Connector Plugin.
                      maxLength: 60
                    content_format:
                      type: string
                      example: ZIP
                      description: Archive format of Custom Connector Plugin.
                      readOnly: true
                      enum:
                      - ZIP
                      - JAR
                    description:
                      type: string
                      description: Description of Custom Connector Plugin.
                      maxLength: 256
                    documentation_link:
                      maxLength: 512
                      type: string
                      pattern: ^$|^(http://|https://).+
                      example: https://github.com/confluentinc/kafka-connect-datagen
                      description: Document link of Custom Connector Plugin.
                    connector_class:
                      type: string
                      maxLength: 150
                      pattern: ^(([a-zA-Z][a-zA-Z_$0-9]*(\.[a-zA-Z][a-zA-Z_$0-9]*)*)\.)?([a-zA-Z][a-zA-Z_$0-9]*)$
                      description: Java class or alias for connector. You can get connector class from
                        connector documentation provided by developer.
                      example: io.confluent.kafka.connect.datagen.DatagenConnector
                      x-immutable: true
                    connector_type:
                      type: string
                      description: 'Custom Connector type.

                        '
                      example: SOURCE
                      x-immutable: true
                      enum:
                      - SOURCE
                      - SINK
                    cloud:
                      type: string
                      description: Cloud provider where the Custom Connector Plugin archive is uploaded.
                      example: AWS
                      default: AWS
                      x-immutable: true
                      enum:
                      - AWS
                      - GCP
                      - AZURE
                    sensitive_config_properties:
                      type: array
                      description: 'A sensitive property is a connector configuration property that must
                        be hidden after a user enters property

                        value when setting up connector.

                        '
                      items:
                        type: string
                        pattern: ^[\w\+\.-]+$
                        maxLength: 150
                      example:
                      - passwords
                      - keys
                      - tokens
                    upload_source:
                      type: object
                      oneOf:
                      - type: object
                        description: Presigned URL of the uploaded Custom Connector Plugin archive.
                        properties:
                          location:
                            type: string
                            description: 'Location of the Custom Connector Plugin source.

                              '
                            example: PRESIGNED_URL_LOCATION
                            enum:
                            - PRESIGNED_URL_LOCATION
                          upload_id:
                            type: string
                            example: e53bb2e8-8de3-49fa-9fb1-4e3fd9a16b66
                            description: Upload ID returned by the `/presigned-upload-url` API. This field
                              returns an empty string in all responses.
                        required:
                        - location
                        - upload_id
                        title: connect.v1.UploadSource.PresignedUrl
                      description: Upload source of Custom Connector Plugin. Only required in `create`
                        request, will be ignored in `read`, `update` or `list`.
                      discriminator:
                        propertyName: location
                        mapping:
                          PRESIGNED_URL_LOCATION:
                            type: object
                            description: Presigned URL of the uploaded Custom Connector Plugin archive.
                            properties:
                              location:
                                type: string
                                description: 'Location of the Custom Connector Plugin source.

                                  '
                                example: PRESIGNED_URL_LOCATION
                                enum:
                                - PRESIGNED_URL_LOCATION
                              upload_id:
                                type: string
                                example: e53bb2e8-8de3-49fa-9fb1-4e3fd9a16b66
                                description: Upload ID returned by the `/presigned-upload-url` API. This
                                  field returns an empty string in all responses.
                            required:
                            - location
                            - upload_id
                            title: connect.v1.UploadSource.PresignedUrl
                    runtime_language:
                      type: string
                      example: JAVA
                      default: JAVA
                      description: Runtime language of Custom Connector Plugin.
                      enum:
                      - JAVA
                      - PYTHON
                  title: connect.v1.CustomConnectorPlugin
                - type: object
                  required:
                  - api_version
                  - kind
                  - id
                  - display_name
                  - connector_class
                  - connector_type
                  - upload_source
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '404':
          description: Not Found
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '404'
                  title: Not Found
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://api.confluent.cloud
        description: Confluent Cloud API